using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.Odbc;
using System.Diagnostics;
using System.ServiceProcess;
using System.Net;

namespace TCPService
{
	/// <summary>
	/// Class that will run as a Windows Service and its display name is
	/// TCP (Sabre Group Config Transfer Service) in Windows Services.
	/// This service basically start a server on service start
	/// (on OnStart method) and shutdown the server on the servie stop
	/// (on OnStop method).
	/// </summary>
	public class TCPService : System.ServiceProcess.ServiceBase
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private TCPServer[] server;

		public TCPService()
		{
			// This call is required by the Windows.Forms Component Designer.
			InitializeComponent();
		}

		// The main entry point for the process
		static void Main()
		{
			System.ServiceProcess.ServiceBase[] ServicesToRun;

			// More than one user Service may run within the same process. To add
			// another service to this process, change the following line to
			// create a second service object. For example,
			//
			//   ServicesToRun = new System.ServiceProcess.ServiceBase[] {new TCPService(), new MySecondUserService()};
			//
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new TCPService() };

			System.ServiceProcess.ServiceBase.Run(ServicesToRun);
		}

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
			this.ServiceName = "MSGService";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Set things in motion so your service can do its work.
		/// </summary>
		protected override void OnStart(string[] args)
		{
			// Create the Server Object ans Start it.
                        OdbcConnection conn=new OdbcConnection("DSN=Message");
                        conn.Open();
                        OdbcCommand cmd = new OdbcCommand("SELECT * FROM Config;",conn);
                        OdbcDataReader data = cmd.ExecuteReader();
                        if(data.HasRows){
                                int count,i;
                        	for(count=0;data.Read();count++);
                                data.Close();
                                data=cmd.ExecuteReader();
                                server= new TCPServer[count];
                                for(i=0;data.Read();i++){
                                	IPAddress ipaddr=IPAddress.Parse(data.GetString(0));
                                        server[i]=new TCPServer(ipaddr);
                                        server[i].StartServer();
                                }

                        }
                        else {

                        	IPHostEntry iphe = Dns.Resolve(Dns.GetHostName());
                                int i=0;
                                server = new TCPServer[iphe.AddressList.Length];
                                for(;i<iphe.AddressList.Length;i++){
                                	server[i]=new TCPServer(iphe.AddressList[i]);
                                        server[i].StartServer();
                                }
                        }
                }
		/// <summary>
		/// Stop this service.
		/// </summary>
		protected override void OnStop()
		{
			// Stop the Server. Release it.
                                int i;
                                for(i=0;i<server.Length;i++){
                                	server[i].StopServer();
		       			server[i]=null;
                                }
                                System.Diagnostics.Debug.WriteLine("Times Executed: "+i.ToString());
                }

	}
}
